ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.18 by root, Sat Mar 17 19:57:02 2007 UTC vs.
Revision 1.73 by root, Mon Oct 26 11:31:39 2009 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@";
14 15
15use Getopt::Long; 16use Getopt::Long;
17use File::Temp;
18use POSIX ();
19use Carp;
20
16use Coro::Event; 21use Coro::EV;
17use AnyEvent; 22use AnyEvent;
23use YAML::XS ();
24use JSON::XS ();
18use IO::AIO (); 25use IO::AIO ();
19use File::Temp; 26
20use Crossfire;
21use Coro; 27use Coro 5.12;
22use Coro::AIO; 28use Coro::AIO;
23use POSIX (); 29use Coro::Util;
24use Digest::MD5; 30use Coro::Channel;
25use Storable; $Storable::canonical = 1; 31use Coro::Storable; $Storable::canonical = 1;
32
33use Deliantra;
34
35$SIG{QUIT} = sub { Carp::cluck "QUIT" };
26 36
27sub usage { 37sub usage {
28 warn <<EOF; 38 warn <<EOF;
29Usage: cfutil [-v] [-q] [--force] [--cache] 39Usage: cfutil [-v] [-q] [--force] [--cache]
30 [--install-arch path] 40 [--install-arch path]
42my $CACHE = 0; 52my $CACHE = 0;
43my $FORCE; 53my $FORCE;
44my $TMPDIR = "/tmp/cfutil$$~"; 54my $TMPDIR = "/tmp/cfutil$$~";
45my $TMPFILE = "aaaa0"; 55my $TMPFILE = "aaaa0";
46 56
57our %COLOR = (
58 black => 0,
59 white => 1,
60 navy => 2,
61 red => 3,
62 orange => 4,
63 blue => 5,
64 darkorange => 6,
65 green => 7,
66 lightgreen => 8,
67 grey => 9,
68 brown => 10,
69 gold => 11,
70 tan => 12,
71);
72
47END { system "rm", "-rf", $TMPDIR } 73END { system "rm", "-rf", $TMPDIR }
48 74
49Event->signal (signal => "INT", cb => sub { exit 1 }); 75my $s_INT = EV::signal INT => sub { exit 1 };
50Event->signal (signal => "TERM", cb => sub { exit 1 }); 76my $s_TERM = EV::signal TERM => sub { exit 1 };
51 77
52mkdir $TMPDIR, 0700 78mkdir $TMPDIR, 0700
53 or die "$TMPDIR: $!"; 79 or die "$TMPDIR: $!";
54 80
55sub fork_sub(&) { 81sub fork_sub(&) {
68} 94}
69 95
70sub inst_maps($) { 96sub inst_maps($) {
71 my (undef, $path) = @_; 97 my (undef, $path) = @_;
72 98
73 print "installing '$path' to '$DATADIR/maps'\n"; 99 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
74 100
75 if (!-f "$path/regions") { 101 if (!-f "$path/regions") {
76 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 102 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
77 exit 1 unless $FORCE; 103 exit 1 unless $FORCE;
78 } 104 }
79 105
80 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded" 106 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
107 "$path/.", "$DATADIR/maps/.",
108 "--exclude", "CVS", "--exclude", "/world-precomposed",
109 "--delete", "--delete-excluded"
81 and die "map installation failed.\n"; 110 and die "map installation failed.\n";
82 111
83 print "maps installed successfully.\n"; 112 print "maps installed successfully.\n";
84} 113}
85 114
86{ 115{
87 our %PNG32; 116 our %ANIMINFO;
88 our %FACEINFO; 117 our %FACEINFO;
118 our %RESOURCE;
89 our @ARC; 119 our @ARC;
120 our %ARC;
90 our $TRS; 121 our $TRS;
91 our $NFILE; 122 our $NFILE;
92 our %ANIM; 123 our $PATH;
93 124
94 our (@png, @trs, @arc); # files we are interested in 125 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
95 126
127 our $c_arc = new Coro::Channel;
128 our $c_trs = new Coro::Channel;
129 our $c_res = new Coro::Channel;
130
131 our @c_png;
132
96 sub commit_png { 133 sub commit_png($$$) {
97 my ($name, $data) = @_; 134 my ($name, $data, $T) = @_;
98 135
99 $PNG32{$name} = $data; 136 $FACEINFO{$name}{"data$T"} = $data;
100 $FACEINFO{$name} ||= {};
101 } 137 }
102 138
103 sub process_png { 139 sub process_png {
104 while (@png) { 140 while (@c_png) {
105 my $path = pop @png; 141 my ($path, $delete) = @{pop @c_png};
106 142
107 my $png; 143 my $png;
108 aio_lstat $path; 144 aio_lstat $path;
109 my ($size, $mtime) = (stat _)[7,9]; 145 my ($size, $mtime) = (stat _)[7,9];
110 146
111 if (0 > aio_load $path, $png) { 147 if (0 > aio_load $path, $png) {
112 warn "$path: $!, skipping.\n"; 148 warn "$path: $!, skipping.\n";
113 next; 149 next;
114 } 150 }
115 151
152 my $stem = $path;
153 my $T;
154
155 if ($stem =~ s/\.32x32\.png~?$//) {
156 $T = 32;
157 } elsif ($stem =~ s/\.64x64\.png~?$//) {
158 $T = 64;
159 } else {
160 warn "$path: weird filename, skipping.\n";
161 next;
162 }
163
116 # quickly extract width and height of the (necessarily PNG) image 164 # quickly extract width and height of the (necessarily PNG) image
117 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 165 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
118 warn "$path: not a recongized png file, skipping.\n"; 166 warn "$path: not a recognized png file, skipping.\n";
119 next; 167 next;
120 } 168 }
121 169
122 my ($w, $h) = unpack "NN", $1; 170 my ($w, $h) = unpack "NN", $1;
123
124 (my $face = $path) =~ s/^.*\///;
125 my $T = 32;
126
127 unless ($face =~ s/\.32x32\.png$//) {
128 warn "$path: weird filename, skipping.\n";
129 next;
130 }
131 171
132 if ($w < $T || $h < $T) { 172 if ($w < $T || $h < $T) {
133 warn "$path: too small ($w $h), skipping.\n"; 173 warn "$path: too small ($w $h), skipping.\n";
134 next; 174 next;
135 } 175 }
137 if ($w % $T || $h % $T) { 177 if ($w % $T || $h % $T) {
138 warn "$path: weird png size ($w $h), skipping.\n"; 178 warn "$path: weird png size ($w $h), skipping.\n";
139 next; 179 next;
140 } 180 }
141 181
182 (my $base = $stem) =~ s/^.*\///;
183
184 my $fi = $FACEINFO{$base};
185 unless ($fi) {
186 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
187 #next;
188 }
189
190 my $arc = $fi->{arc} || { };
191
192 unless ($path =~ /~$/) {
193 # possibly enlarge
194 if (0 > aio_stat "$stem.64x64.png") {
195 my $other = "$stem.64x64.png~";
196
197 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
198 fork_sub {
199 my $CROP;
200 my $SRC = "png:\Q$path\E";
201
202 my $is_floor = $arc->{is_floor};
203 my $is_wall = 0;
204
205 my ($wall_pfx, $wall_dir, $wall_sfx);
206
207 if (
208 !$is_floor
209 && !$arc->{alive}
210 && $arc->{move_block} eq "all"
211 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
212 ) {
213 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
214
215 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
216 $is_wall = 1;
217 }
218 }
219
220 if ($is_wall || $is_floor) {
221 # add a 4px border and add other images around it
222 $CROP = "-shave 8x8 +repage";
223
224 $w += 8;
225 $h += 8;
226
227 $SRC = "-size ${w}x${h} xc:transparent";
228 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
229
230 # 8 surrounding images
231 for (
232 # x y b r0 r1
233 [-1, -1, 0, 6],
234 [ 0, -1, 1, 10, 14],
235 [+1, -1, 0, 12],
236
237 [-1, 0, 8, 5, 7],
238 #
239 [+1, 0, 2, 5, 13],
240
241 [-1, +1, 0, 3],
242 [ 0, +1, 4, 10, 11],
243 [+1, +1, 0, 9],
244 ) {
245 my ($x, $y, $d, $r0, $r1) = @$_;
246
247 my $tile = $is_floor ? $path
248 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
249 : die;
250
251 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
252 "\Q$tile",
253 $x * ($w - 8) + 4,
254 $y * ($h - 8) + 4;
255 }
256 }
257
258 system "convert -depth 8 $SRC rgba:-"
259 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
260 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
261 and die "convert/cfhq2xa pipeline error: status $? ($!)";
262 system $OPTIPNG, "-i0", "-q", "$other~";
263 die "$other~ has zero size, aborting." unless -s "$other~";
264 rename "$other~", $other;
265 };
266 }
267
268 push @c_png, [$other, !$CACHE];
269 }
270
271 # possibly scale down
272 if (0 > aio_stat "$stem.32x32.png") {
273 my $other = "$stem.32x32.png~";
274
275 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
276 fork_sub {
277 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
278 system $OPTIPNG, "-i0", "-q", "$other~";
279
280 # reduce smoothfaces >10000 bytes
281 # obsolete, no longer required
282 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
283 my $ncolor = 256;
284 while () {
285 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
286 system $OPTIPNG, "-i0", "-q", "$other~~";
287 last if 10000 > -s "$other~~";
288 $ncolor = int $ncolor * 0.9;
289 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
290 }
291
292 printf "reduced %s from %d to %d bytes using %d colours.\n",
293 $other, -s "$other~", -s "$other~~", $ncolor
294 if $VERBOSE >= 2;
295 rename "$other~~", "$other~";
296 }
297
298 die "$other~ has zero size, aborting." unless -s "$other~";
299 rename "$other~", $other;
300 };
301 }
302
303 #warn "scaled down $path to $other\n";#d#
304 push @c_png, [$other, !$CACHE];
305 }
306 }
307
308 (my $face = $stem) =~ s/^.*\///;
309
310 # split all bigfaces, but avoid smoothfaces (*_S)
142 if (($w > $T || $h > $T) && $face !~ /_S\./) { 311 if (($w > $T || $h > $T) && $face !~ /_S\./) {
143 # split 312 # split
144 my @tile; 313 my @tile;
145 for my $x (0 .. (int $w / $T) - 1) { 314 for my $x (0 .. (int $w / $T) - 1) {
146 for my $y (0 .. (int $h / $T) - 1) { 315 for my $y (0 .. (int $h / $T) - 1) {
160 ( 329 (
161 "(", 330 "(",
162 "+clone", 331 "+clone",
163 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 332 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
164 "+repage", 333 "+repage",
334 -quality => "00",
165 -write => "png:$_->[2]~", 335 -write => "png32:$_->[2]~",
166 "+delete", 336 "+delete",
167 ")", 337 ")",
168 ) 338 )
169 } @todo), 339 } @todo),
170 "null:"; 340 "null:";
174 close $convert; 344 close $convert;
175 345
176 # pass 2, optimise, and rename 346 # pass 2, optimise, and rename
177 for (@todo) { 347 for (@todo) {
178 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 348 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
349 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
179 rename "$_->[2]~", $_->[2]; 350 rename "$_->[2]~", $_->[2];
180 } 351 }
181 }; 352 };
182 } 353 }
183 354
187 358
188 if (0 > aio_load $file, $tile) { 359 if (0 > aio_load $file, $tile) {
189 die "$path: unable to read tile +$x+$y, aborting.\n"; 360 die "$path: unable to read tile +$x+$y, aborting.\n";
190 } 361 }
191 IO::AIO::aio_unlink $file unless $CACHE; 362 IO::AIO::aio_unlink $file unless $CACHE;
192 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 363 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
193 } 364 }
194 } else { 365 } else {
195 # use as-is (either small, use smooth) 366 # use as-is (either small, use smooth)
196 commit_png $face, $png; 367 commit_png $face, $png, $T;
197 } 368 }
369
370 aio_unlink $path if $delete;
198 } 371 }
199 } 372 }
200 373
201 sub process_arc { 374 sub process_arc {
202 while (@arc) { 375 while (my $job = $c_arc->get) {
203 my ($dir, $file) = @{pop @arc}; 376 my ($dir, $file) = @$job;
204 377
205 my $arc; 378 my $arc;
206 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 379 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
207 380
208 my $arc = read_arch "$dir/$file"; 381 my $arc = read_arch "$dir/$file";
209 for my $o (values %$arc) { 382 for my $o (values %$arc) {
210 push @ARC, $o; 383 push @ARC, $o;
384 for (my $m = $o; $m; $m = $m->{more}) {
385 $ARC{$m->{_name}} = $m;
386 }
211 387
212 $o->{editor_folder} = $dir; 388 $o->{editor_folder} = $dir;
213 389
214 my $visibility = delete $o->{visibility}; 390 my $visibility = delete $o->{visibility};
215 my $magicmap = delete $o->{magicmap}; 391 my $magicmap = delete $o->{magicmap};
226 my $x = $o->{x} - $dx; 402 my $x = $o->{x} - $dx;
227 my $y = $o->{y} - $dy; 403 my $y = $o->{y} - $dy;
228 404
229 my $ext = $x|$y ? "+$x+$y" : ""; 405 my $ext = $x|$y ? "+$x+$y" : "";
230 406
231 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/; 407 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
232 408
233 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 409 $visibility = delete $o->{visibility} if exists $o->{visibility};
234 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 410 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
235 411
236 my $anim = delete $o->{anim}; 412 my $anim = delete $o->{anim};
237 413
238 if ($anim) { 414 if ($anim) {
415 # possibly add $ext to the animation name to avoid
416 # the need to specify archnames for all parts
417 # of a multipart archetype.
239 $o->{animation} = "$o->{_name}"; 418 $o->{animation} = "$o->{_name}";
419 my $facings = 1;
420 my @frames;
240 421
241 for (@$anim) { 422 for (@$anim) {
242 $_ .= $ext unless /^facings\s|^blank.x11$|^empty.x11$/; 423 if (/^facings\s+(\d+)/) {
424 $facings = $1*1;
425 } elsif (/^blank.x11$|^empty.x11$/) {
426 push @frames, $_;
427 } else {
428 push @frames, "$_$ext";
429 }
243 } 430 }
244 431
245 $ANIM{"$o->{_name}$ext"} = 432 $ANIMINFO{$o->{animation}} = {
246 join "", map "$_\n", 433 facings => $facings,
247 "anim $o->{_name}", 434 frames => \@frames,
248 @$anim,
249 "mina";
250 } 435 };
436 }
251 437
252 for my $face ($o->{face} || (), @{$anim || []}) { 438 for ($o->{face} || (), @{$anim || []}) {
253 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/; 439 next if /^facings\s/;
254 440
441 my $face = $_;
442 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
443
255 my $info = $FACEINFO{$face} ||= {}; 444 my $info = $FACEINFO{$face} ||= { };
445 $info->{arc} = $o;
446
447 next if $face =~ /^blank.x11$|^empty.x11$/;
256 448
257 $info->{visibility} = $visibility if defined $visibility; 449 $info->{visibility} = $visibility if defined $visibility;
258 $info->{magicmap} = $magicmap if defined $magicmap; 450 $info->{magicmap} = $magicmap if defined $magicmap;
259 } 451 }
260 452
261 if (my $smooth = delete $o->{smoothface}) { 453 if (my $smooth = delete $o->{smoothface}) {
262 my ($face, $smooth) = split /\s+/, $smooth; 454 my %kv = split /\s+/, $smooth;
263 # skip empty_S.x11, it seems to server no purpose whatsoever 455 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
264 # but increases bandwidth demands and worse. 456 while (my ($face, $smooth) = each %kv) {
265 unless ($smooth eq "empty_S.x11") { 457 $FACEINFO{$smooth}{arc} = $o;
458
266 $FACEINFO{$face}{smooth} = $smooth; 459 $FACEINFO{$face}{smooth} = $smooth;
460 $FACEINFO{$face}{smoothlevel} = $level;
267 } 461 }
268 } 462 }
269 } 463 }
270 } 464 }
271 } 465 }
272 } 466 }
273 467
274 sub process_trs { 468 sub process_trs {
275 while (@trs) { 469 while (my $job = $c_trs->get) {
276 my ($dir, $file) = @{pop @trs}; 470 my ($dir, $file) = @$job;
277 my $path = "$dir/$file"; 471 my $path = "$dir/$file";
278 472
279 my $trs; 473 my $trs;
280 if (0 > aio_load $path, $trs) { 474 if (0 > aio_load $path, $trs) {
281 warn "$path: $!, skipping.\n"; 475 warn "$path: $!, skipping.\n";
284 478
285 $TRS .= $trs; 479 $TRS .= $trs;
286 } 480 }
287 } 481 }
288 482
483 my %FILECACHE;
484
485 sub load_cached($;$) {
486 unless (exists $FILECACHE{$_[0]}) {
487 my $data;
488 if (0 < aio_load $_[0], $data) {
489 if ($_[1]) {
490 $data = eval { $_[1]->($data) };
491 warn "$_[0]: $@" if $@;
492 }
493 }
494
495 $FILECACHE{$_[0]} = $data;
496 }
497
498 $FILECACHE{$_[0]}
499 }
500
501 sub process_res {
502 while (my $job = $c_res->get) {
503 my ($dir, $file, $type) = @$job;
504
505 my $data;
506 aio_load "$dir/$file", $data;
507
508 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
509
510 utf8::decode $dir;
511 utf8::decode $file;
512
513 # a meta file for resources is now mandatory
514 unless (exists $meta->{$file}) {
515 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
516 next;
517 }
518
519 $meta = {
520 %{ $meta->{"" } || {} },
521 %{ $meta->{$file} || {} },
522 };
523
524 if ($meta->{license} =~ s/^#//) {
525 $meta->{license} = ({
526 "pd" => "Public Domain",
527 "gpl" => "GNU General Public License, version 3.0 or any later",
528 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
529 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
530 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
531 })->{$meta->{license}}
532 || warn "$dir/$file: license tag '$meta->{license}' not found.";
533 }
534
535 $file =~ s/\.res$//;
536 $file =~ s/\.(ogg|wav|jpg|png)$//;
537
538 substr $dir, 0, 1 + length $PATH, "";
539
540 if (my $filter = $meta->{cfutil_filter}) {
541 if ($filter eq "yaml2json") {
542 $data = JSON::XS::encode_json YAML::XS::Load $data;
543 } elsif ($filter eq "json2json") {
544 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
545 } elsif ($filter eq "perl2json") {
546 $data = eval $data; die if $@;
547 $data = JSON::XS::encode_json $data;
548 } else {
549 warn "$dir/$file: unknown filter $filter, skipping\n";
550 }
551 }
552
553 $RESOURCE{"$dir/$file"} = {
554 type => (exists $meta->{type} ? delete $meta->{type} : $type),
555 data => $data,
556 %$meta ? (meta => $meta) : (),
557 };
558 }
559 }
560
289 sub find_files; 561 sub find_files;
290 sub find_files { 562 sub find_files {
291 my ($path) = @_; 563 my ($path) = @_;
292 564
293 IO::AIO::aioreq_pri 4; 565 IO::AIO::aioreq_pri 4;
295 my ($dirs, $nondirs) = @_; 567 my ($dirs, $nondirs) = @_;
296 568
297 find_files "$path/$_" 569 find_files "$path/$_"
298 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 570 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
299 571
572 my $dir = $path;
573 substr $dir, 0, 1 + length $PATH, "";
574
300 for my $file (@$nondirs) { 575 for my $file (@$nondirs) {
576 if ($dir =~ /^music(?:\/|$)/) {
577 $c_res->put ([$path, $file, 3]) # FT_MUSIC
578 if $file =~ /\.(ogg)$/;
579
580 } elsif ($dir =~ /^sound(?:\/|$)/) {
581 $c_res->put ([$path, $file, 5]) # FT_SOUND
582 if $file =~ /\.(wav|ogg)$/;
583
584 } elsif ($dir =~ /^res(?:\/|$)/) {
585 if ($file =~ /\.(jpg|png)$/) {
586 $c_res->put ([$path, $file, 0]) # FT_FACE
587 } elsif ($file =~ /\.(res)$/) {
588 $c_res->put ([$path, $file, 6]) # FT_RSRC
589 } else {
590 $c_res->put ([$path, $file, undef]);
591 }
592
301 if ($file =~ /\.png$/) { 593 } elsif ($file =~ /\.png$/) {
302 push @png, "$path/$file"; 594 push @c_png, ["$path/$file", 0];
595
303 } elsif ($file =~ /\.trs$/) { 596 } elsif ($file =~ /\.trs$/) {
304 push @trs, [$path, $file]; 597 $c_trs->put ([$path, $file]);
598
305 } elsif ($file =~ /\.arc$/) { 599 } elsif ($file =~ /\.arc$/) {
306 push @arc, [$path, $file]; 600 $c_arc->put ([$path, $file]);
601
307 } else { 602 } else {
308 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 603 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
309 } 604 }
310 } 605 }
311 }; 606 };
607 }
608
609 sub generate_plurals {
610# use Lingua::EN::Inflect ();
611# Lingua::EN::Inflect::classical;
612# Lingua::EN::Inflect::def_noun 'talisman' => 'talismans';
613# Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
614#
615# for my $a (@ARC) {
616# my $name = $a->{name} || $a->{_name};
617#
618# next unless $a->{name_pl};
619#
620#
621# my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
622# my $pl = $test =~ /^(?:eq|p:.)$/
623# ? $name
624# : Lingua::EN::Inflect::PL $name;
625# die "$test $pl" if $pl =~ /bootss/;#d#
626#
627# if ($pl ne $a->{name_pl}) {
628# warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
629# }
630# }
312 } 631 }
313 632
314 sub inst_arch($) { 633 sub inst_arch($) {
315 my (undef, $path) = @_; 634 my (undef, $path) = @_;
316 635
636 $PATH = $path;
637
638 print "\n",
317 print "installing '$path' to '$DATADIR'\n"; 639 "Installing '$path' to '$DATADIR'\n",
640 "\n",
641 "This can take a long time if you run this\n",
642 "for the first time or do not use --cache.\n",
643 "\n",
644 "Unless you run verbosely, all following warning\n",
645 "or error messages indicate serious problems.\n",
646 "\n";
318 647
319 if (!-d "$path/treasures") { 648 if (!-d "$path/treasures") {
320 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 649 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
321 exit 1 unless $FORCE; 650 exit 1 unless $FORCE;
322 } 651 }
323 652
653 print "scanning files...\n" if $VERBOSE;
654
324 find_files $path; 655 find_files $path;
656
657 my @a_arc = map +(async \&process_arc), 1..2;
658 my @a_res = map +(async \&process_res), 1..2;
659 my @a_trs = map +(async \&process_trs), 1..2;
660
325 IO::AIO::flush; 661 IO::AIO::flush;
326 662
327 $_->join for ( 663 $c_res->shutdown;
328 (async \&process_png), (async \&process_png), 664 $c_arc->shutdown;
329 (async \&process_trs), (async \&process_trs), 665 $c_trs->shutdown;
330 (async \&process_arc), (async \&process_arc),
331 );
332 666
667 print "start file scan, arc, res processing...\n" if $VERBOSE;
668
669 $_->join for @a_arc; # need to parse all archetypes before png processing
670
671 print "end arc, start png processing...\n" if $VERBOSE;
672
673 # eight png crunchers work fine for my 4x smp machine
674 my @a_png = map +(async \&process_png), 1..8;
675
676 $_->join for (@a_trs, @a_res, @a_png);
677
678 print "scanning done, processing results...\n" if $VERBOSE;
333 { 679 {
334 open my $fh, ">:utf8", "$DATADIR/animations~" 680 # remove path prefix from editor_folder
335 or die "$DATADIR/animations~: $!"; 681 substr $_->{editor_folder}, 0, 1 + length $path, ""
336 print $fh join "", map $ANIM{$_}, sort keys %ANIM 682 for values %ARC;
683
684 print "resolving inheritance tree...\n" if $VERBOSE;
685 # resolve inherit
686 while () {
687 my $progress;
688 my $loop;
689
690 for my $o (values %ARC) {
691 if (my $other = $o->{inherit}) {
692 if (my $s = $ARC{$other}) {
693 if ($s->{inherit}) {
694 $loop = $s;
695 } else {
696 delete $o->{inherit};
697 my %s = %$s;
698 delete @s{qw(_name more name name_pl)};
699 %$o = ( %s, %$o );
700 ++$progress;
701 }
702 } else {
703 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
704 delete $ARC{$o->{_name}};
705 }
706 }
707 }
708
709 unless ($progress) {
710 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
711 if $loop;
712
713 last;
714 }
337 } 715 }
338 716
339 { 717 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
718 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
719
720 print "generating plurals...\n" if $VERBOSE;
721 generate_plurals;
722
723 print "writing archetypes...\n" if $VERBOSE;
340 open my $fh, ">:utf8", "$DATADIR/archetypes~" 724 open my $fh, ">:utf8", "$DATADIR/archetypes~"
341 or die "$DATADIR/archetypes~: $!"; 725 or die "$DATADIR/archetypes~: $!";
342 substr $_->{editor_folder}, 0, 1 + length $path, "" for @ARC; 726 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
343 print $fh Crossfire::archlist_to_string \@ARC;
344 } 727 }
345 728
346 { 729 {
730 print "writing treasures...\n" if $VERBOSE;
347 open my $fh, ">:utf8", "$DATADIR/treasures~" 731 open my $fh, ">:utf8", "$DATADIR/treasures~"
348 or die "$DATADIR/treasures~: $!"; 732 or die "$DATADIR/treasures~: $!";
349 print $fh $TRS; 733 print $fh $TRS;
350 } 734 }
351 735
352 { 736 {
353 while (my ($k, $v) = each %FACEINFO) { 737 print "processing facedata...\n" if $VERBOSE;
354 $v->{data32} ||= delete $PNG32{$k};
355 }
356
357 while (my ($k, $v) = each %FACEINFO) { 738 while (my ($k, $v) = each %FACEINFO) {
358 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n"; 739 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
740 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
359 741
360 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 742 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
743 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
744
745 if (my $magicmap = $v->{magicmap}) {
746 $magicmap =~ y/A-Z_\-/a-z/d;
747 $v->{magicmap} = $COLOR{$magicmap};
361 } 748 }
362 749
750 delete $v->{arc};
751 }
752
753 print "writing facedata...\n" if $VERBOSE;
363 open my $fh, ">:perlio", "$DATADIR/faces~" 754 open my $fh, ">:perlio", "$DATADIR/facedata~"
364 or die "$DATADIR/faces~: $!"; 755 or die "$DATADIR/facedata~: $!";
365 756
366 $FACEINFO{""} = { version => 1}; 757 print $fh freeze {
367 print $fh Storable::nfreeze \%FACEINFO; 758 version => 2,
759 faceinfo => \%FACEINFO,
760 animinfo => \%ANIMINFO,
761 resource => \%RESOURCE,
368 } 762 };
763 }
369 764
765 print "committing files...\n" if $VERBOSE;
766
370 for (qw(archetypes faces animations treasures)) { 767 for (qw(archetypes facedata treasures)) {
371 chmod 0644, "$DATADIR/$_~"; 768 chmod 0644, "$DATADIR/$_~";
372 rename "$DATADIR/$_~", "$DATADIR/$_" 769 rename "$DATADIR/$_~", "$DATADIR/$_"
373 or die "$DATADIR/$_: $!"; 770 or die "$DATADIR/$_: $!";
374 } 771 }
375 772

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines